﻿Imports System.Text
Imports System.Security.Cryptography
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WpfDesktopEdition
Imports System.Reflection

Class MainWindow
    Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
    End Sub

    Private Sub WpfMap_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Map1.Loaded
        'Map1.ZoomLevelSet = New OpenStreetMapsZoomLevelSet()
        OSMLayer()
        Map1.Refresh()
    End Sub



    Private Sub OSMLayer()

        Map1.MapUnit = GeographyUnit.Meter
        'Map1.CurrentExtent = New RectangleShape(-13939426, 6701997, -7812401, 2626987)

        Dim osm As New OpenStreetMapOverlay
        osm.TransitionEffect = TransitionEffect.Stretch
        osm.Name = "Base Layer"
        Map1.Overlays.Add("BASE", osm)

    End Sub

    Private Sub Button_Click_3(sender As Object, e As RoutedEventArgs)

        Dim LayerName As String = "BASE"

        Try
            Select Case Map1.Overlays.Item(LayerName).GetType()

                Case GetType(OpenStreetMapOverlay)
                    Map1.CurrentExtent = ExtentHelper.SnapToZoomLevel(Map1.Overlays.Item(LayerName).GetBoundingBox(), Map1.MapUnit, Map1.ActualWidth, Map1.ActualHeight, Map1.ZoomLevelSet)
                    Map1.Refresh()

                Case GetType(LayerOverlay)
                    Map1.CurrentExtent = ExtentHelper.SnapToZoomLevel(Map1.Overlays.Item(LayerName).GetBoundingBox(), Map1.MapUnit, Map1.ActualWidth, Map1.ActualHeight, New OpenStreetMapsZoomLevelSet())
                    Map1.Refresh()

            End Select

        Catch ex As Exception
            Debug.Print("Error:" & ex.Message)
        End Try

    End Sub



    Private Sub RasterClick(sender As Object, e As RoutedEventArgs)

        Dim RasterPath As String = "D:\Projects\SpatialestX\Data\TerraColor_SanFrancisco_US_15mX.tif"
        Dim proj4 As Proj4Projection = New Proj4Projection()

        Dim rasterLayer As New ThinkGeo.MapSuite.Core.GdiPlusRasterLayer(RasterPath)

        'rasterLayer.UpperThreshold = 100000000
        'rasterLayer.LowerThreshold = 0

        proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326)
        proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString()
        rasterLayer.ImageSource.Projection = proj4


        Dim newOverlay As New LayerOverlay()
        newOverlay.TileType = TileType.SingleTile
        newOverlay.TransitionEffect = TransitionEffect.Stretch
        newOverlay.Layers.Add(rasterLayer)

        Map1.CurrentExtent = ExtentHelper.SnapToZoomLevel(newOverlay.GetBoundingBox(), Map1.MapUnit, Map1.ActualWidth, Map1.ActualHeight, New ZoomLevelSet())
        Map1.Overlays.Add("RASTER", newOverlay)
        Map1.Refresh()

    End Sub


End Class
